/*
 * Copyright 2013 Akiban Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.akiban.jonquil;

import org.codehaus.jackson.JsonLocation;

public final class JonquilException extends RuntimeException {
    public JonquilException(String message) {
        super(message);
    }

    public JonquilException(String message, Throwable cause) {
        super(message, cause);
    }

    @Override
    public String getMessage() {
        String orig = super.getMessage();
        if (atLocation == null)
            return orig;
        return String.format("%s (at line %d, column %d)", orig, atLocation.getLineNr(), atLocation.getColumnNr());
    }

    public void setLocation(JsonLocation atLocation) {
        this.atLocation = atLocation;
    }

    private volatile JsonLocation atLocation;
}
