/*
 * Copyright 2013 Akiban Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.akiban.jonquil.actions;

import com.akiban.jonquil.JonquilException;
import com.akiban.jonquil.JonquilWriter;
import org.codehaus.jackson.JsonParser;
import org.codehaus.jackson.JsonToken;

import java.io.IOException;

@SuppressWarnings("unused")
final class Limit implements Action {
    @Override
    public void apply(JsonParser input, JonquilWriter output, String tableName) throws IOException {
        if (input.nextToken() != JsonToken.VALUE_NUMBER_INT)
            throw new JonquilException("@limit must take an integer");
        int limit = input.getIntValue();
        output.setLimit(limit);
    }
}
